#include <iostream>
#include <vector>
#include <bitset>
#include <algorithm>

using namespace std;

// n <= 100
// m <= 1000
// any k
// t = 1

const int MAXM = 1000;

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int mt;
    cin >> mt;
    while (mt--) {
        int n, k, m, t;
        cin >> n >> k >> m >> t;
        string s;
        cin >> s;

        bitset<MAXM> ones;
        for (int i = 0; i < m; i++) {
            ones[i] = true;
        }

        vector<vector<int>> val(n, vector<int> (n));
        for (int i = 0; i < n; i++) {
            val[i][i] = (s[i] - '0') % m;
            for (int j = i + 1; j < n; j++) {
                val[i][j] = (val[i][j - 1] * 10 + (s[j] - '0')) % m;
            }
        }

        vector<vector<bitset<MAXM>>> dp(n, vector<bitset<MAXM>> (n));
        for (int l = 1; l <= n; l++) {
            for (int i = 0; i + l <= n; i++) {
                int j = i + l - 1;
                dp[i][j][val[i][j]] = true;
                for (int j1 = i; j1 < j; j1++) {
                    int v = val[j1 + 1][j];

                    dp[i][j] |= (dp[i][j1] << v) & ones;
                    dp[i][j] |= (dp[i][j1] >> (m - v));
                }
            }
        }

        k++;
        bool ok = false;
        for (int ans = 0; ans < m; ans++) {
            vector<vector<bool>> dp1(n + 1, vector<bool> (k + 1));
            vector<vector<int>> prev1(n + 1, vector<int> (k + 1));
            prev1[0][0] = -1;
            dp1[0][0] = true;
            for (int i = 0; i < n; i++) {
                for (int c = 0; c < k; c++) {
                    if (dp1[i][c]) {
                        for (int j = i; j < n; j++) {
                            if (dp[i][j][ans]) {
                                dp1[j + 1][c + 1] = true;
                                prev1[j + 1][c + 1] = i;
                            }
                        }
                    }
                }
            }

            if (dp1[n][k]) {
                vector<int> begs;
                int cur = n;
                int cc = k;
                while (cur != -1) {
                    begs.push_back(cur);
                    cur = prev1[cur][cc];
                    cc--;
                }
                reverse(begs.begin(), begs.end());

                vector<bool> eq(n);
                for (int i = 1; i < begs.size() - 1; i++) {
                    eq[begs[i] - 1] = true;
                }

                vector<bool> plus(n);

                for (int i = 0; i < k; i++) {
                    int l = begs[i];
                    int r = begs[i + 1] - 1;
                    int vl = ans;

                    for (int r1 = r - 1; r1 >= l; r1--) {
                        int vl1 = (vl - val[r1 + 1][r] + m) % m;
                        if (dp[l][r1][vl1]) {
                            plus[r1] = true;
                            r = r1;
                            vl = vl1;
                        }
                    }
                }

                for (int i = 0; i < n; i++) {
                    cout << s[i];
                    if (eq[i]) {
                        cout << "=";
                    }
                    if (plus[i]) {
                        cout << "+";
                    }
                }
                cout << "\n";

                ok = true;
                break;
            }
        }

        if (!ok) {
            cout << "Fail\n";
        }
    }

    return 0;
}
