#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>

using namespace std;

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, k;
    cin >> n >> k;

    vector<int> sqs;

    vector<int> x(n), y(n), xx(n), yy(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> y[i] >> xx[i] >> yy[i];
        sqs.push_back(max(abs(x[i]), abs(y[i])));
        sqs.push_back(max(abs(xx[i]), abs(yy[i])));
    }

    int xa, ya, xb, yb;
    cin >> xa >> ya >> xb >> yb;

    sqs.push_back(max(abs(xa), abs(ya)));
    sqs.push_back(max(abs(xb), abs(yb)));

    sort(sqs.begin(), sqs.end());
    sqs.resize(unique(sqs.begin(), sqs.end()) - sqs.begin());

    vector<pair<int, int>> pts;
    for (int i = 0; i < n; i++) {
        pts.push_back({x[i], y[i]});
        pts.push_back({xx[i], yy[i]});
    }
    for (int s : sqs) {
        pts.push_back({s, s});
        pts.push_back({-s, s});
        pts.push_back({s, -s});
        pts.push_back({-s, -s});
    }

    pts.push_back({xa, ya});
    pts.push_back({xb, yb});

    sort(pts.begin(), pts.end());
    pts.resize(unique(pts.begin(), pts.end()) - pts.begin());

    vector<vector<double>> d(pts.size(), vector<double>(pts.size(), INFINITY));

    map<int, vector<pair<int, int>>> hors, verts;
    for (int i = 0; i < pts.size(); i++) {
        d[i][i] = 0;
        hors[pts[i].first].push_back({pts[i].second, i});
        verts[pts[i].second].push_back({pts[i].first, i});
    }

    for (auto &hs : hors) {
        sort(hs.second.begin(), hs.second.end());
        for (int i = 0; i + 1 < hs.second.size(); i++) {
            int u = hs.second[i].second;
            int v = hs.second[i + 1].second;
            if (max(abs(hs.second[i].first), abs(hs.first)) ==
                max(abs(hs.second[i + 1].first), abs(hs.first)) &&
                    abs(hs.first) >= hs.second[i].first &&
                    abs(hs.first) >= hs.second[i + 1].first) {

                double dd = abs(hs.second[i].first - hs.second[i + 1].first);

                d[u][v] = min(d[u][v], dd);
                d[v][u] = min(d[v][u], dd);
            }
        }
    }

    for (auto &vs : verts) {
        sort(vs.second.begin(), vs.second.end());
        for (int i = 0; i + 1 < vs.second.size(); i++) {
            int u = vs.second[i].second;
            int v = vs.second[i + 1].second;
            if (max(abs(vs.second[i].first), abs(vs.first)) ==
                max(abs(vs.second[i + 1].first), abs(vs.first)) &&
                abs(vs.first) >= vs.second[i].first &&
                abs(vs.first) >= vs.second[i + 1].first) {

                double dd = abs(vs.second[i].first - vs.second[i + 1].first);

                d[u][v] = min(d[u][v], dd);
                d[v][u] = min(d[v][u], dd);
            }
        }
    }

    map<pair<int, int>, int> ind;
    for (int i = 0; i < pts.size(); i++) {
        ind[pts[i]] = i;
    }

    for (int i = 0; i < n; i++) {
        int u = ind[{x[i], y[i]}];
        int v = ind[{xx[i], yy[i]}];
        double dd = hypot(x[i] - xx[i], y[i] - yy[i]);

        d[u][v] = min(d[u][v], dd);
        d[v][u] = min(d[v][u], dd);
    }

    for (int r = 0; r < pts.size(); r++) {
        for (int i = 0; i < pts.size(); i++) {
            for (int j = 0; j < pts.size(); j++) {
                d[i][j] = min(d[i][j], d[i][r] + d[r][j]);
            }
        }
    }

    cout.precision(20);
    if (d[ind[{xa, ya}]][ind[{xb, yb}]] == INFINITY) {
        cout << -1 << endl;
    } else {
        cout << d[ind[{xa, ya}]][ind[{xb, yb}]]<< endl;
    }
    return 0;
}